//+------------------------------------------------------------------+
//|                                                    The Abyss.mq4 |
//|                                              Copyright  2007,Richard Benson . |
//|                                        
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, ."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       Magic=2003;
extern string    EAName="TheAbyss";


extern int _3bartrailpips=500;

extern string  D ="Heiken Ashi Smoothed";
extern int     MaMetod  = 2;
extern int     MaPeriod = 6;
extern int     MaPeriod2 = 2;

extern string  DT ="TrendManager";
extern int TM_Period = 7;
extern int TM_Shift = 2;

extern string  DS ="Slope Direction Line";
extern int       period=20;
extern int       method=1;
extern int       price=0;

extern double Lots = 0.01;

extern int    slippage=2;
extern int    shift=2;

bool buysig,sellsig,closebuy,closesell;
int last,buys,sells;





//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()  {
   buys=0; sells=0;
   string symbol=Symbol();
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        {
         if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {

   	
   	double TML=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,0,shift);
   	double TMS=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,1,shift);
      double hasOpenLong=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaPeriod2,1,shift) ;
      double hasCloseLong=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaPeriod2,3,shift) ;
      double hasOpenShort=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaPeriod2,0,shift) ;
      double hasCloseShort=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaPeriod2,2,shift) ;
      double SDLL=iCustom(NULL,0,"Slope Direction Line",period,method,price,0,shift);
      double SDLS=iCustom(NULL,0,"Slope Direction Line",period,method,price,1,shift);
  



      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;

    
      bool Long1 = TML;
      bool Short1 = TMS;
      bool Long2 = SDLL;
      bool Short2 = SDLS;
      bool Long3 = hasOpenLong < hasCloseLong;
      bool Short3 = hasOpenShort > hasCloseShort;

      buysig = Long1 && Long2 && Long3;
      sellsig = Short1 && Short2 && Short3;

      closebuy=sellsig;
      closesell=buysig;
      
}

void CheckForOpen() {

   if (last==Time[0]) return;

   int    res,ord;
   double entry,stop;

   ord=CalculateCurrentOrders();

   if (ord!=0) CheckForClose();

//---- buy conditions
   if (buys< buysig)  {
		res=OpenAtMarket(OP_BUY,Lots);
		if (res<0) Print("Error opening BUY order : ",(GetLastError()));
		else last=Time[0];
   }
//---- sell conditions
   if (sells< sellsig)  {
		res=OpenAtMarket(OP_SELL,Lots);
		if (res<=0) Print("Error opening SELL order : ",(GetLastError()));
		else last=Time[0];
   }
}
  
int OpenAtMarket(int mode,double lot) {
   int    tr,col;
   double openprice;
        tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELL) {
         openprice=Bid; 
         col=Red;
      } else {
         //openprice=nd(Ask);
         openprice=Ask;
         col=Blue;
      }
      OrderSend(Symbol(),mode,lot,openprice,slippage,EAName+Magic,Magic,0,col);
      
   }
   return;

  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
	int total;
//----
	total=OrdersTotal();
   for(int i=total;i>=0;i--)
        {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))  continue;
      if(OrderMagicNumber()!=Magic || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY &&  closebuy) CloseAtMarket(OrderTicket(),OrderLots());
      if(OrderType()==OP_SELL && closesell) CloseAtMarket(OrderTicket(),OrderLots());
     }
}

bool CloseAtMarket(int ticket,double lot) {
   bool bres=false; int tr;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      if (!bres) Print("Error closing order : ",(GetLastError()));
      
   }

void Trail3Bar() {
   //_3bartrailpips
   bool bres;
   double StopLoss,H3,L3=99999;
   int i=0,cnt=3;
   
   while (i<=cnt) {
      i++;
      if (i>Bars-1) break;
      if (High[i]<=High[i+1] && Low[i]>=Low[i+1]) { cnt++; continue; } //skip inside Bar
      H3=MathMax(H3,High[i]);
      L3=MathMin(L3,Low[i]);
   }
   L3=L3-_3bartrailpips*Point;
   H3=H3+_3bartrailpips*Point;
   double stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   if (L3>=Bid-stlev) L3=Bid-stlev; 
   if (H3<=Ask+stlev) H3=Ask+stlev; 
   for (i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != Magic )  continue;
      if ( OrderType() == OP_BUY ) {
         StopLoss = L3;
         if ( StopLoss > OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         StopLoss = H3;
         if ( StopLoss < OrderStopLoss() || OrderStopLoss()<Point ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",(GetLastError()));
         }
      }
   }
}



//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {

   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   //---- check for signals
   CheckForSignals();

   CheckForOpen();
   
   Trail3Bar();
   
   
   
}